/*
 * Kernel Traffic retrieval tool.
 *
 * (C) 1999 Alan Cox.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 */
 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <fcntl.h> 
#include <errno.h>
#include <sys/time.h>

#include "config.h"
#include "engine.h"
#include "portaloo.h"

int main(int argc, char *argv[])
{
	int s;
	int head=1;
	int ct=0;	
	int iol = 0;
	char *p;
	char buf[256];
	char base[256];
	FILE *f;
	
	if(argc!=2)
	{
		fprintf(stderr,"%s [num]\n", argv[0]);
		exit(1);
	}	
	snprintf(buf, sizeof(buf), PORTALOO_BASE"%s.new", argv[1]);
	snprintf(base, sizeof(buf), PORTALOO_BASE"%s.out", argv[1]);
	
	f=fopen(buf, "w");
	if(f==NULL)
	{
		perror(buf);
		exit(1);
	}
	
	s=host_connect("www.kt.opensrc.org",80);
	if(s==-1)
		return 1;
	
	host_get(s, "www.kt.opensrc.org", "/latest.html");
	
	fprintf(f,"Kernel Traffic\nhttp://www.kt.opensrc.org\nKernel Traffic\n--\n");
	fprintf(f,"<br clear=all><FONT size=\"-1\" face=\"helvetica\"><UL><P>\n");
	
	while((p=host_readline(s))!=NULL)
	{
		char *app;
		if(head && *p!=0 && *p!='\r')
			continue;
		
		if(head)
		{		
			head = 0;
			continue;
		}
		
		if(memcmp(p, " <ol>",5)==0)
		{
			iol=1;
			continue;
		}
		if(memcmp(p, "</ol>",6)==0)
		{
			iol=0;
			continue;
		}
		if(!iol)
			continue;
		
		if(memcmp(p, " <li><a href=\"#",15))
			continue;

		fprintf(f,"<LI><A href=\"http://www.kt.opensrc.org/latest.html#%s\n", p+15);
		ct++;
		if(ct==10)
			fprintf(f,"--\n");
	}
	fprintf(f,"</UL></FONT>\n");
	fclose(f);
	if(rename(buf,base)==-1)
	{
		perror("rename");
		exit(1);
	}
	exit(0);
}
	